/**
 * Copyright (c) 2004-2014 Gabor Bergmann and Daniel Varro
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-v20.html.
 * 
 * SPDX-License-Identifier: EPL-2.0
 */
package org.eclipse.viatra.query.runtime.rete.recipes;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Relation Evaluation Recipe</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * @since 2.8
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.query.runtime.rete.recipes.RelationEvaluationRecipe#getEvaluator <em>Evaluator</em>}</li>
 * </ul>
 *
 * @see org.eclipse.viatra.query.runtime.rete.recipes.RecipesPackage#getRelationEvaluationRecipe()
 * @model
 * @generated
 */
public interface RelationEvaluationRecipe extends MultiParentNodeRecipe {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright (c) 2004-2014 Gabor Bergmann and Daniel Varro\nThis program and the accompanying materials are made available under the\nterms of the Eclipse Public License v. 2.0 which is available at\nhttp://www.eclipse.org/legal/epl-v20.html.\n\nSPDX-License-Identifier: EPL-2.0"; //$NON-NLS-1$

	/**
	 * Returns the value of the '<em><b>Evaluator</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Evaluator</em>' reference.
	 * @see #setEvaluator(ExpressionDefinition)
	 * @see org.eclipse.viatra.query.runtime.rete.recipes.RecipesPackage#getRelationEvaluationRecipe_Evaluator()
	 * @model
	 * @generated
	 */
	ExpressionDefinition getEvaluator();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.query.runtime.rete.recipes.RelationEvaluationRecipe#getEvaluator <em>Evaluator</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Evaluator</em>' reference.
	 * @see #getEvaluator()
	 * @generated
	 */
	void setEvaluator(ExpressionDefinition value);

} // RelationEvaluationRecipe
